﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace CAN_2018C_demo
{
    public partial class Form1 : Form
    {
        //---  global variable ------
        Byte VxCAN_port;
        Graphics g;
        Pen p;
        Bitmap img ;
        int count;
        float VoltLast;
        float v_max = 10, v_min = -10;
        string unit = "";

        //--------------------------

        public Form1()
        {
            InitializeComponent();
            img = new Bitmap(pictureBox1.Width, pictureBox1.Height);
        }

        //get VxCAN_DotNET.dll version
        private void Btn_GetDLLVersion_Click(object sender, EventArgs e)
        {
            UInt32 ret;
            Char[] ch = new Char[600];

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_DLL_Ver(ch);
            if (ret == 0)
            {
                String _str = new String(ch);
                MessageBox.Show(_str);
            }
        }


        private void Btn_SearchModule_Click(object sender, EventArgs e)
        {
            UInt32 ret;
            byte Percentage = 0;
            pBar_SearchModule.Value = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_SearchCANModule();
            if (ret == 0)
            {
                while (pBar_SearchModule.Value < pBar_SearchModule.Maximum)
                {

                    ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_IsSearchCANModuleOK(ref Percentage);
                    pBar_SearchModule.Value = Convert.ToInt32(Percentage);
                }

                MessageBox.Show("Search Done!");
            }
        }

        private void Btn_GetModuleList_Click(object sender, EventArgs e)
        {
            Byte _TotalVxCANPort = 0;
            Byte[] _VxCAN_LocalPortIDList = new Byte[50];
            UInt32 ret = 0;
            UInt32[] _VxCAN_NameIDList = new UInt32[50];
            UInt32[] _VxCAN_IDList = new UInt32[50];
            UInt32[] _VxCAN_COMPortBaudRate = new UInt32[50];
            String[] _VxCAN_NameStr = new String[50];
            String[] _VxCAN_VerStr = new String[50];

            dataGridView1.Columns.Clear();
            dataGridView1.Rows.Clear();
            dataGridView1.Columns.Add("VxCANPort", "VxCANPort");
            dataGridView1.Columns.Add("VxCAN_NameIDList", "VxCAN_NameIDList");
            dataGridView1.Columns.Add("VxCAN_IDList", "VxCAN_IDList");
            dataGridView1.Columns.Add("VxCAN_COMPortBaudRate", "VxCAN_COMPortBaudRate");
            dataGridView1.Columns.Add("VxCAN_NameStr", "VxCAN_NameStr");
            dataGridView1.Columns.Add("VxCAN_VerStr", "VxCAN_VerStr");
            dataGridView1.Columns.Add("VxCAN_LocalPortIDList", "VxCAN_LocalPortIDList");



            for (int i = 0; i < 50; i++)
            {
                //Set Default Value
                _VxCAN_NameStr[i] = new String('\0', 50);
                _VxCAN_VerStr[i] = new String('\0', 50);
            }



            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_TotalCANPort(ref _TotalVxCANPort, _VxCAN_NameIDList, _VxCAN_IDList, _VxCAN_COMPortBaudRate, _VxCAN_NameStr, _VxCAN_VerStr, _VxCAN_LocalPortIDList);
            if (ret == 0)
            {
                for (int i = 0; i < _TotalVxCANPort; i++)
                {
                    dataGridView1.Rows.Add();
                    dataGridView1["VxCANPort", dataGridView1.Rows.Count - 1].Value = i;
                    dataGridView1["VxCAN_NameIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameIDList[i];
                    dataGridView1["VxCAN_NameIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameIDList[i];
                    dataGridView1["VxCAN_IDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_IDList[i];

                    //2015C is not a UART module so its VxCAN_COMPortBaudRate = 0xFFFFFFFF
                    //we use -1 to represent that
                    if (_VxCAN_COMPortBaudRate[i] == 0xFFFFFFFF)
                        dataGridView1["VxCAN_COMPortBaudRate", dataGridView1.Rows.Count - 1].Value = -1;
                    else
                        dataGridView1["VxCAN_COMPortBaudRate", dataGridView1.Rows.Count - 1].Value = _VxCAN_COMPortBaudRate[i];
                    dataGridView1["VxCAN_NameStr", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameStr[i];
                    dataGridView1["VxCAN_VerStr", dataGridView1.Rows.Count - 1].Value = _VxCAN_VerStr[i];
                    dataGridView1["VxCAN_LocalPortIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_LocalPortIDList[i];
                }
            }
        }
        //default CAN baud rate is 1000Kbps, use that open CAN port
        private void Btn_OpenCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_OpenCAN((Byte)dataGridView1.CurrentRow.Index, (UInt32)VxCAN_DotNET.VxCAN_DotNET.CAN_BaudRate.BR_1000K);
            if (ret == 0)
            {
                MessageBox.Show("Open CAN Port 0 done!!");
            }
            VxCAN_port = (Byte)dataGridView1.CurrentRow.Index;
            comboBox1.SelectedIndex = 0;
            comboBox2.SelectedIndex = 0;
            comboBox3.SelectedIndex = 0;
        }
        //close CAN port
        private void Btn_CloseCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCAN_port);
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearTxBuffer(VxCAN_port);
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_CloseCAN(VxCAN_port);
        }

        private void Btn_ResetCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ResetCAN(0);
            if (ret == 0)
                MessageBox.Show("Reset CAN Port 0 done!");
        }

        private void Btn_CANStatus_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;
            UInt32 ModuleStatus = 0;
            UInt32 CANChipStatus = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_CANStatus(0, ref ModuleStatus, ref CANChipStatus);
            if (ret == 0)
            {
                MessageBox.Show("Module Status = " + ModuleStatus.ToString());
                MessageBox.Show("CAN Chip Status = " + CANChipStatus.ToString());
            }
        }

        //Start operation mode
        private void button1_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox3.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox3.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            ID = 0x000;
            Len = 0x2;
            Data[0] = 0x01;
            Data[1] = DataID;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
            MessageBox.Show("CAN2018C is in operation mode!");


        }

        private void Btn_SendCANMsg_Click(object sender, EventArgs e)
        {
            int type, channel;

            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox3.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox3.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            type = (comboBox1.SelectedIndex);
            channel = (comboBox2.SelectedIndex + 1);

            g = Graphics.FromImage(img);
            g.Clear(Color.White);

            switch (type)
            {
                case 0:
                    Data[4] = 0x00;
                    v_max = 15;
                    v_min = -15;
                    break;
                case 1:
                    Data[4] = 0x01;
                    v_max = 50;
                    v_min = -50;
                    break;
                case 2:
                    Data[4] = 0x02;
                    v_max = 100;
                    v_min = -100;
                    break;
                case 3:
                    Data[4] = 0x03;
                    v_max = 500;
                    v_min = -500;
                    break;
                case 4:
                    Data[4] = 0x04;
                    v_max = 1;
                    v_min = -1;
                    break;
                case 5:
                    Data[4] = 0x05;
                    v_max = 2.5f;
                    v_min = -2.5f;
                    break;
                case 6:
                    Data[4] = 0x06;
                    v_max = 20;
                    v_min = -20;
                    break;
                case 7:// J type
                    Data[4] = 0x0E;
                    v_max = 500;
                    v_min = -500;
                    break;
                case 8:// K type
                    Data[4] = 0x0F;
                    v_max = 1200;
                    v_min = -210;
                    break;
                case 9:// T type
                    Data[4] = 0x10;
                    v_max = 1372;
                    v_min = -270;
                    break;
                case 10:// E type
                    Data[4] = 0x11;
                    v_max = 1000;
                    v_min = -270;
                    break;
                case 11:// R type
                    Data[4] = 0x12;
                    v_max = 1765;
                    v_min = -50;
                    break;
                case 12:// S type
                    Data[4] = 0x13;
                    v_max = 1765;
                    v_min = -50;
                    break;
                case 13:// B type
                    Data[4] = 0x14;
                    v_max = 1820;
                    v_min = 0;
                    break;
                case 14:// N type
                    Data[4] = 0x15;
                    v_max = 1300;
                    v_min = -270;
                    break;
                case 15:// C type
                    Data[4] = 0x16;
                    v_max = 2320;
                    v_min = 0;
                    break;
            }

            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x04;
            Data[2] = 0x20;
            Data[3] = (byte)channel;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            Thread.Sleep(10);

            if (channel < 5)
            {
                Data[1] = 0x01;
                Data[2] = 0x18;
            }
            else if (channel >= 5 && channel < 9)
            {
                Data[1] = 0x02;
                Data[2] = 0x18;
            }
            else
            {
                Data[1] = 0x03;
                Data[2] = 0x18;
            }

            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2B;
            Data[3] = 0x05;
            Data[4] = 0xE8;
            Data[5] = 0x03;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);


            //Initialize Graphics								
            g.Clear(Color.White);

            Draw_Background();
            //Initialize time, last voltage data and enable Timer
            count = 0;
            VoltLast = 0;
            Timer1.Interval = 100;
            Timer1.Enabled = true;

        }

        private void Btn_SendStopMsg_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox3.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox3.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];
            int channel;
            channel = (comboBox2.SelectedIndex + 1);

            if (channel < 5)
            {
                Data[1] = 0x01;
                Data[2] = 0x18;
            }
            else
            {
                Data[1] = 0x02;
                Data[2] = 0x18;
            }
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2B;
            Data[3] = 0x05;
            Data[4] = 0x00;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
            //Stop timer
            Timer1.Enabled = false;
        }
        private void Draw_Background()
        {
            double a;
            int height, width;
            height = pictureBox1.Height;
            width = pictureBox1.Width;
            g.Clear(Color.White);
            p = new Pen(Color.Blue, 1);
            a = v_max / 4.0;
            int type = comboBox1.SelectedIndex;

            switch (type)
            {
                case 0:
                case 1:
                case 2:
                case 3:
                    unit = " mV";
                    break;
                case 4:
                case 5:
                    unit = " V";
                    break;
                case 6:
                    unit = " mA";
                    break;
                case 7:
                case 8:
                case 9:
                case 10:
                case 11:
                case 12:
                case 13:
                case 14:
                case 15:
                    unit = " ℃";
                    break;
            }

            //label for temperature range 
            label1.Text = v_max.ToString() + unit;
            label2.Text = (a * 3).ToString() + unit;
            label3.Text = (a * 2).ToString() + unit;
            label4.Text = a.ToString() + unit;
            label5.Text = "0" + unit;
            label6.Text = (0 - a).ToString() + unit;
            label7.Text = (0 - a * 2).ToString() + unit;
            label8.Text = (0 - a * 3).ToString() + unit;
            label10.Text = (0 - v_max).ToString() + unit;

            //Draw X Y axis. Limit max time = 60 seconds
            p.DashStyle = DashStyle.Solid;
            p.EndCap = LineCap.ArrowAnchor;
            g.DrawLine(p, 5, 95, pictureBox1.Width, 95);
            g.DrawLine(p, 5, 95, 5, 5);
            g.DrawLine(p, 5, 95, 5, 185);
            //Draw separate line for temperature range
            p.DashStyle = DashStyle.Dash;
            g.DrawLine(p, 5, 5, pictureBox1.Width, 5);
            g.DrawLine(p, 5, 27, pictureBox1.Width, 27);
            g.DrawLine(p, 5, 50, pictureBox1.Width, 50);
            g.DrawLine(p, 5, 72, pictureBox1.Width, 72);
            g.DrawLine(p, 5, 117, pictureBox1.Width, 117);
            g.DrawLine(p, 5, 140, pictureBox1.Width, 140);
            g.DrawLine(p, 5, 162, pictureBox1.Width, 162);
            g.DrawLine(p, 5, 185, pictureBox1.Width, 185);

        }

        private void Timer1_Tick(object sender, System.EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox3.SelectedIndex + 1);
            byte VxCANPort = VxCAN_port, rMode = 0, rRTR = 0, rLen = 0;
            UInt32 ret = 0, rID = 0;
            byte[] rdata = new byte[8];
            Double rMsgTimeStamps = 0;
            int channel_index = comboBox2.SelectedIndex;
            int a = 0x0;
            double Vch = 0;
            float Volt = 0;
            int channel = channel_index + 1;


            g = Graphics.FromImage(img);
            Pen p = new Pen(Color.Black, 3);

            if (channel < 5)
                rID = (ushort)(0x280 + NumID);
            else
                rID = (ushort)(0x380 + NumID);


            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_Receive(VxCANPort, ref rID, ref rMode, ref rRTR, ref rLen, rdata, ref rMsgTimeStamps);
            if (ret == 0)
            {
                //Clean buffer for Latest Data
                VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);

                if (rID == (0x280 + NumID) || rID == (0x380 + NumID))
                {
                    //Convert input data to the corresponding temperature value and formula is below
                    switch (channel_index)
                    {
                        case 0:
                            a = rdata[1] * 256 + rdata[0];
                            break;
                        case 1:
                            a = rdata[3] * 256 + rdata[2];
                            break;
                        case 2:
                            a = rdata[5] * 256 + rdata[4];
                            break;
                        case 3:
                            a = rdata[7] * 256 + rdata[6];
                            break;
                        case 4:
                            a = rdata[1] * 256 + rdata[0];
                            break;
                        case 5:
                            a = rdata[3] * 256 + rdata[2];
                            break;
                        case 6:
                            a = rdata[5] * 256 + rdata[4];
                            break;
                        case 7:
                            a = rdata[7] * 256 + rdata[6];
                            break;

                    }
                    if (a >= 0x8000)
                    {
                        a = 0x10000 - a;
                        a = -a;
                    }
                    Vch = a * v_max * 2 / 65535.0;
                    Volt = (float)Math.Round(Vch, 2);


                    //Reset graphics when 60 seconds of arrival 
                    if (count == 60 || count == 0)
                    {
                        count = 0;
                        Draw_Background();
                    }

                    //let temperature be bounded
                    if (Volt > v_max)
                        Volt = v_max;
                    if (Volt < v_min)
                        Volt = v_min;

                    textBox2.Text = Volt.ToString() + unit;
                    textBox3.Text = count.ToString() + "s";

                    //Draw trand chart with black line
                    if (count != 0)
                    {
                        g.DrawLine(p, TOX(count - 1), TOY(VoltLast), TOX(count), TOY(Volt));
                        pictureBox1.Refresh();
                    }
                    pictureBox1.Refresh();

                    //increase time and record last voltage value for trend chart
                    count++;
                    VoltLast = Volt;
                }


            }

            
        }

        //To fit the graphics scale of X axis
        float TOX(float a1)
        {
            float x;
            x = 5 + (pictureBox1.Width - 10) / (float)(60.0) * a1;
            return x;
        }

        //To fit the graphics scale of Y axis 
        float TOY(float b1)
        {
            float y;
            y = (pictureBox1.Height) / 2 - ((pictureBox1.Height - 10) / 2 - 0) / (float)(v_max) * b1;
            return y;
        }

        private void CAN2018_Paint(object sender, PaintEventArgs e)
        {
            pictureBox1.Image = img;
        }
    }
}
